package com.ruoyi.mall.controller;

import java.util.List;

import com.ruoyi.mall.domain.MallOrderBack;
import com.ruoyi.mall.service.IMallOrderBackService;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.mall.domain.MallOrderGoods;
import com.ruoyi.mall.service.IMallOrderGoodsService;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.common.core.page.TableDataInfo;

/**
 * 订单商品Controller
 *
 * @author chang
 * @date 2021-11-25
 */
@RestController
@RequestMapping("/mall/mallOrderGoods")
public class MallOrderGoodsController extends BaseController
{
    @Autowired
    private IMallOrderGoodsService mallOrderGoodsService;
    @Autowired
    private IMallOrderBackService mallOrderBackService;

    /**
     * 查询订单商品列表
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:list')")
    @GetMapping("/list")
    public TableDataInfo list(MallOrderGoods mallOrderGoods)
    {
        startPage();
        List<MallOrderGoods> list = mallOrderGoodsService.selectMallOrderGoodsList(mallOrderGoods);
        return getDataTable(list);
    }

    /**
     * 订单商品客户购买数量统计
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:list')")
    @GetMapping("/selectMallOrderGoodsTotal")
    public TableDataInfo selectMallOrderGoodsTotal(MallOrderGoods mallOrderGoods)
    {
        startPage();
        List<MallOrderGoods> list = mallOrderGoodsService.selectMallOrderGoodsTotal(mallOrderGoods);
        return getDataTable(list);
    }

    /**
     * 导出订单商品列表
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:export')")
    @Log(title = "订单商品", businessType = BusinessType.EXPORT)
    @GetMapping("/export")
    public AjaxResult export(MallOrderGoods mallOrderGoods)
    {
        List<MallOrderGoods> list = mallOrderGoodsService.selectMallOrderGoodsTotal(mallOrderGoods);
        ExcelUtil<MallOrderGoods> util = new ExcelUtil<MallOrderGoods>(MallOrderGoods.class);
        return util.exportExcel(list, "订单商品数据");
    }

    /**
     * 获取订单商品详细信息
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id)
    {
        return AjaxResult.success(mallOrderGoodsService.selectMallOrderGoodsById(id));
    }

    /**
     * 新增订单商品
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:add')")
    @Log(title = "订单商品", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody MallOrderGoods mallOrderGoods)
    {
        return toAjax(mallOrderGoodsService.insertMallOrderGoods(mallOrderGoods));
    }

    /**
     * 修改订单商品
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:edit')")
    @Log(title = "订单商品", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody MallOrderGoods mallOrderGoods)
    {
        return toAjax(mallOrderGoodsService.updateMallOrderGoods(mallOrderGoods));
    }

    /**
     * 删除订单商品
     */
    @PreAuthorize("@ss.hasPermi('mall:mallOrderGoods:remove')")
    @Log(title = "订单商品", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids)
    {
        return toAjax(mallOrderGoodsService.deleteMallOrderGoodsByIds(ids));
    }

    /**
     * 查询退货订单商品列表
     */
    @GetMapping("/getOrderBackList")
    public TableDataInfo getOrderBackList(MallOrderGoods mallOrderGoods)
    {
        MallOrderBack mallOrderBack = mallOrderBackService.selectMallOrderBackById(mallOrderGoods.getOrderBackId());
        mallOrderGoods.setOrderId(mallOrderBack.getOrderId());
        startPage();
        List<MallOrderGoods> list = mallOrderGoodsService.getOrderBackList(mallOrderGoods);
        return getDataTable(list);
    }
}
